﻿xquery version "1.0" encoding "UTF-8";
(: Bibliothèque pour les exercices du chapitre IV :)
module namespace bib="http://mes-guides-randos/bib";
declare namespace g="http://mes-guides-randos";
declare variable $bib:itinéraires as element(g:itinéraire)* := fn:doc("queyras.xml")//g:itinéraire;  
declare function bib:départ-itinéraire($i as element(g:itinéraire))
        as element(lieu)?
   {
   if (fn:matches($i//g:para[1], "^(De |Du |D')[^(]* \([1-9][0-9]{3} m\).*")) then
      let $para := $i//g:para[1]
      let $suite :=
         if (fn:starts-with($para, "De ")) then
            fn:substring-after($para, "De ")
         else
            if (fn:starts-with($para, "Du ")) then 
               fn:substring-after($para, "Du ") 
            else
               fn:substring-after($para, "D'")
      let $nom :=
          fn:normalize-space(fn:substring-before($suite, "("))
      let $alt :=
          fn:substring-after(
             fn:substring-before($suite, " m)"),
             "(")
      return <lieu nom="{$nom}" alt="{$alt}"/>
   else
      ()
   };
declare variable $bib:noms-lieux-départ as xs:string* :=
   fn:distinct-values(
      for $d in 
         (for $i in $bib:itinéraires
          return bib:départ-itinéraire($i))
      let $n := fn:string($d/@nom)
      order by fn:upper-case($n)
      return $n);
declare variable $bib:étapes as element(étape)* :=
   {
   for $i1 in $bib:itinéraires
   for $i2 in $bib:itinéraires except $i1
   let $d1 := bib:départ-itinéraire($i1),
       $d2 := bib:départ-itinéraire($i2)
   where $d1 and $d2 and $d1/@nom ne $d2/@nom and $i1/g:nom = $i2/g:nom
   return <étape départ="{$d1/@nom}"
                 montée="{$i1/@id}"
                 sommet="{$i1/g:nom}"
                 descente="{$i2/@id}"
                 arrivée="{$d2/@nom}"/>
   };
declare function bib:étapes-depuis($nom-lieu as xs:string)
        as element(étape)*
   {
   for $e in $bib:étapes
   where $e/@départ = $nom-lieu
   return $e
   };
declare function bib:construire-traversées($traversées-1 as element(traversée)*)
        as element(traversée)*
   {
   let $traversées-2 :=
      for $t in $traversées-1
      let $étapes-suivantes := 
         bib:étapes-depuis($t/étape[fn:last()]/@arrivée)
      for $e in $étapes-suivantes
      where fn:not($e/@arrivée = ($t/étape[1]/@départ, $t/étape/@arrivée))
      return
         <traversée>{$t/étape, $e}</traversée>
   return
      if (fn:count($traversées-2) = 0) then
         $traversées-1
      else
         bib:construire-traversées($traversées-2)
   };
declare variable $bib:traversées-les-plus-longues as element(traversée)* :=
   {
   bib:construire-traversées(
      for $e in $bib:étapes
      return <traversée>{$e}</traversée>)
   };
declare function bib:nom-traversée($t as element(traversée))
        as xs:string
   {
   fn:string-join(
      (for $e in $t/étape
       return fn:string-join(($e/@montée, $e/@descente), "-")),
      "/")
   };
