﻿xquery version "1.0" encoding "UTF-8";
(: Bibliothèque pour le chapitre IV :)
module namespace bib="http://mes-guides-randos/bib";
import schema namespace g="http://mes-guides-randos" 
       at "s1-sans-accents.xsd";
declare variable $bib:queyras :=
   validate strict {fn:doc("queyras-sans-accents.xml")};
declare variable $bib:secteurs := $bib:queyras//g:secteur;
declare function bib:est-secteur-pour-bons-skieurs($s)
        as xs:boolean
   {
   let $itis := $s//g:itineraire
   return
      every $i in $s//g:itineraire 
      satisfies $i/g:cotation ge "**"
   };
declare function bib:trajets-de-à($s1 as element(g:secteur), 
                                  $s2 as element(g:secteur))
        as element()*
   {
   for $i1 in $s1/g:itineraire
   for $i2 in $s2/g:itineraire
   where $i1/g:nom = $i2/g:nom
   return <trajet>
             {fn:data($i1/@id)}-{$i1/g:nom/text()}-{fn:data($i2/@id)}
          </trajet>
   };
declare function bib:désannoter-para($p as element(g:para))
        as element(g:para)
   {
   <g:para>
      {
      for $n in $p/node()
      return
         typeswitch($n)
         case element(g:renvoi) return
            (text {"itinéraire no "}, 
             text {fn:substring-after(fn:data($n/@cible), ".")})
         case element(g:note) return $n/text()
         default return $n
      }
   </g:para>
   };
declare function bib:désannoter-noeud($n as node()) as node()
   {
   typeswitch($n)
   case element(g:para) return bib:désannoter-para($n)
   case element() return
      element 
         {fn:concat("g:", fn:local-name($n))}
         {
         $n/attribute::*,
         for $e in $n/child::node()
         return bib:désannoter-noeud($e)
         }
   case document-node() return 
      document {bib:désannoter-noeud($n/*)}
   default return $n
   };
