﻿xquery version "3.0" encoding "UTF-8";
import module namespace bib="http://mes-itineraires/bib" 
              at "b2-sans-accents.xquery";
declare namespace iti="http://mes-itineraires";
(: Dénivelés par tranche de 0 à 199, 200 à 399, 400 à 599, ... 
   en omettant les tranches vides :)
declare function local:no-tranche($n as xs:integer)
        as xs:integer
   {$n idiv 200};
declare function local:tranche($n as xs:integer) 
        as xs:string
   {
   let $début := local:no-tranche($n) * 200
   return $début || "-" || ($début + 199)
   };
<réponse>
   {
   let $dénivelés :=
      (for $d in $bib:itineraires-queyras//fn:data(iti:denivele)
       order by $d
       return $d)
   for tumbling window $w in $dénivelés
      start when fn:true()
      end $i-der next $i-suiv
          when fn:empty($i-suiv) or
               local:no-tranche($i-suiv) > local:no-tranche($i-der)
   return <tranche val="{local:tranche($i-der)}">{$w}</tranche>
   }
</réponse>